\name{summary.nnreg}
\alias{summary.nnreg}
\title{
  Summary for neural net regression 
}
\description{ Extracts some summary fit information from the nnreg object 
and formats the results as a matrix. The main items are the RMSE and GCV 
functions fro different numbers of hidden units. }

\usage{
summary.nnreg(out, noprint=F, digits = 4)
}
\arguments{
\item{out}{
A nnreg object 
}
\item{noprint}{
Just return the summary matrix do not print it.
}
\item{digits}{
Number of significant digits for printing the summary.
}
}
\value{
Gives a summary of the neural net regression. The components 
include the function call, number of hidden units, number of parameters, 
degree of freedom of residuals, root mean squared error and GCV. 
}
\details{
This produces a summary of the nnreg fit. For lack of any creativity this 
is the same as the results for print.nnreg. 
}
\seealso{
nnreg, summary, print.nnreg  
}
\examples{
nnreg(ozone$x,ozone$y,1,2) -> fit # fitting a surface to ozone  
# measurements, from 1 to 2 hidden units 
summary(fit) # summary of fit 
}
\keyword{neural}
% docclass is function
% Converted by Sd2Rd version 1.21.
